var urlText = null;

var gBlock = null;
var gXMLHttpRequest = null;
var URL = "";
var bookmarksXML = null;
var bnum = 1;
var delname = null, delurl = null;

function saveBookmarks() {
 var serializer = new XMLSerializer();
 var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
               .createInstance(Components.interfaces.nsIFileOutputStream);
 var file = Components.classes["@mozilla.org/file/directory_service;1"]
           .getService(Components.interfaces.nsIProperties)
           .get("ProfD", Components.interfaces.nsIFile); // get profile folder
 file.append("bookmarks.xml");   // filename
 foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);   // write, create, truncate
 serializer.serializeToStream(bookmarksXML, foStream, "");   // rememeber, doc is the DOM tree
 foStream.close();
}

function deleteBookmark(){
 if(delname==null && delurl == null)return;
 var l=bookmarksXML.documentElement.firstChild;
 while(l!=null){
  try{
   if(l.getAttribute("name")==delname && l.getAttribute("url")==delurl){
    bookmarksXML.documentElement.removeChild(l);
    saveBookmarks();
    break;
   }
  }
  catch(e){}
  l=l.nextSibling;
 }
 var rt=document.getElementById("bookmarks-popup");
 l=rt.firstChild;
 while(l!=null){
  try{
   if(l.getAttribute("label")==delname && l.getAttribute("oncommand")=="loadFromURL(\""+delurl+"\")"){
    rt.removeChild(l);
    break;
   }
  }
  catch(e){}
  l=l.nextSibling;
 }

 delname=delurl=null;
}

function addBookmarkGUI(name,url){
 var menu = document.getElementById("bookmarks-popup");
 var num = menu.childNodes;
 if(num!=null)num=num.length+1;
 else num=1;
 var entry = document.createElement("menuitem");
 entry.setAttribute("label",name);
 entry.setAttribute("oncommand","loadFromURL(\""+url+"\")");
 entry.setAttribute("context","bkmkmenu"); 
 entry.setAttribute("onclick","{delname=\""+name+"\";delurl=\""+url+"\";}"); 
 entry.setAttribute("class", "menuitem-iconic bookmark");
 menu.appendChild(entry);
}

function insertBookmark(name,url){
 if(name!=null && url!=null){
  if(name=='')
   name=url;
  var l=bookmarksXML.documentElement.firstChild;
  while(l!=null){
   try{
    if(l.getAttribute("name")==name)return false;
   }
   catch(e){}
   l=l.nextSibling;
  }
  addBookmarkGUI(name,url);
  var ch = bookmarksXML.createElement("bookmark");
  ch.setAttribute("name",name);
  ch.setAttribute("url",url);
  bookmarksXML.documentElement.appendChild(ch);
  return true;
 }
 return false;
}

function addBookmark(url){
 var name=prompt("Bookmark name");
 if(insertBookmark(name,url))
   saveBookmarks();
}

function renameBookmark(newname){
 if(delname==null && delurl == null)return;
 var l=bookmarksXML.documentElement.firstChild;
 while(l!=null){
  try{
   if(l.getAttribute("name")==delname && l.getAttribute("url")==delurl){
    l.setAttribute("name",newname);
    saveBookmarks();
    break;
   }
  }
  catch(e){}
  l=l.nextSibling;
 }
 var rt=document.getElementById("bookmarks-popup");
 l=rt.firstChild;
 while(l!=null){
  try{
   if(l.getAttribute("label")==delname && l.getAttribute("oncommand")=="loadFromURL(\""+delurl+"\")"){
    l.setAttribute("label",newname);
    l.setAttribute("onclick","{delname=\""+newname+"\";delurl=\""+delurl+"\";}");
    break;
   }
  }
  catch(e){}
  l=l.nextSibling;
 }

 delname=delurl=null;
}

function delBookmarkEvent(event){
 deleteBookmark();
}

function renBookmarkEvent(event){
 document.getElementById("go-popup").hidePopup();
 
 var l=prompt("Bookmark name");
 if(l!=null && l!='')
  renameBookmark(l);
}

function loadBookmarks() {
 var p=new DOMParser();
 try{
  var foStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                .createInstance(Components.interfaces.nsIFileInputStream);
  var file = Components.classes["@mozilla.org/file/directory_service;1"]
            .getService(Components.interfaces.nsIProperties)
            .get("ProfD", Components.interfaces.nsIFile); // get profile folder
  file.append("bookmarks.xml");   // filename
  foStream.init(file, 0x01, 0664, 0);
  var sstr = Components.classes["@mozilla.org/scriptableinputstream;1"]
            .createInstance(Components.interfaces.nsIScriptableInputStream);
  sstr.init(foStream);
  bookmarksXML = p.parseFromString(sstr.read(sstr.available()),"text/xml");
 }
 catch(e){
  bookmarksXML = p.parseFromString("<bookmarks></bookmarks>","text/xml");
 }
 for(var b = bookmarksXML.documentElement.firstChild; b != null; b = b.nextSibling) {
  if(b.nodeType == 1)
   addBookmarkGUI(b.getAttribute("name"),b.getAttribute("url"));
 }
 var rp = document.getElementById("bkmkrnm");
 rp.addEventListener('command',renBookmarkEvent,true);
 var dp = document.getElementById("bkmkdel");
 dp.addEventListener('command',delBookmarkEvent,true);
}

function tryLoad() {
  urlText = document.getElementById("urlText");

  // remove all child nodes of the content's body
  var dbody = document.getElementById("block");
  while(dbody.firstChild)
    dbody.removeChild(dbody.firstChild);

  if("arguments" in window && 0 in window.arguments) // if the argument was passed
    gBlock = window.arguments[0];

  // set url in urlbar
  if("arguments" in window && 1 in window.arguments) { // if the argument was passed
    URL = window.arguments[1];
    urlText.value = URL;
  }

  if(gBlock) {
    if("send" in gBlock) {
      document.getElementById("sendToolbarbutton").setAttribute("disabled", "false");
    }

    document.getElementById("editSourceBroadcaster").setAttribute("disabled", "false");
    document.getElementById("saveAsBroadcaster").setAttribute("disabled", "false");
    document.getElementById("saveToMailboxBroadcaster").setAttribute("disabled", "false");

    if("brandListener" in gBlock) // [BUG] fixed, temporary approach
      gBlock.brandListener = brandListener;

    gBlock.decode(document.getElementById("block"));
  }

  loadBookmarks();
}

function createNewMessage() {
  try {
    window.openDialog("try.xul", "_blank", "chrome, dialog=false", new RFC822Mauer(""));
  }
  catch(ex) {
    alert(ex);
  }
}

function saveToFile() {
  try {
    var message = gBlock.encode();
  }
  catch(ex) {
    alert(ex);
    return;
  }

  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Save to File", nsIFilePicker.modeSave);
  fp.appendFilters(nsIFilePicker.filterAll);

  var rv = fp.show();
  if(rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
    var file = fp.file;

    // file is nsIFile, data is a string
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

    foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
    foStream.write(message, message.length);
    foStream.close();
  }
}

function saveToMailbox() {
  try {
    var message = gBlock.encode();
  }
  catch(ex) {
    alert(ex);
    return;
  }

  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Save to Mailbox", nsIFilePicker.modeSave);
  fp.appendFilters(nsIFilePicker.filterAll);

  var rv = fp.show();
  if(rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
    var file = fp.file;

    // file is nsIFile
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

    var header = "\r\nFrom - " + (new Date().toGMTString()) + "\r\n";
    var subject = window.prompt("Enter Subject", "");
    header += "Subject: " + subject + "\r\n";
    header += "To: " + gBlock.to + "\r\n";
    header += "From: " + gBlock.from + "\r\n";
    header += "Date: " + (new Date().toGMTString()) + "\r\n";
    message = "\r\n" + message + "\r\n";

    if(subject) {
      foStream.init(file, 0x02 | 0x10, 0664, 0); // write, append
      foStream.write(header, header.length);
      foStream.write(message, message.length);
      foStream.close();
    }
  }

}

function openFile() {
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Open File", nsIFilePicker.modeOpen);
  fp.appendFilters(nsIFilePicker.filterAll);

  var rv = fp.show();
  if(rv == nsIFilePicker.returnOK) {
    var file = fp.file;

    // file is nsIFile
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    URL = fileHandler.getURLSpecFromFile(file);

    // set url in urlbar
    urlText.value = URL;

    // open an input stream from file
    var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    istream.init(file, 0x01, 0444, 0);
    istream.QueryInterface(Components.interfaces.nsILineInputStream);

    // read first line
    var line = new Object();
    istream.readLine(line);
    var matchString = line.value;
    istream.close();

    // create stream to read all data
    istream.init(file, 0x01, 0444, 0);
    var scstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
    scstream.init(istream);

    // load document according to it's type
    // get file type (from first line)
    gBlock = loadFromStream(scstream, matchString);
    try {
      // create interface to invoke operations
      gBlock.decode(document.getElementById("block"));
    }
    catch(ex) {
      alert(ex);
    }
    document.getElementById("editSourceBroadcaster").setAttribute("disabled", "false");
    document.getElementById("saveAsBroadcaster").setAttribute("disabled", "false");
    document.getElementById("saveToMailboxBroadcaster").setAttribute("disabled", "false");
    if("send" in gBlock)
      document.getElementById("sendToolbarbutton").setAttribute("disabled", "false");
    else
      document.getElementById("sendToolbarbutton").setAttribute("disabled", "true");

    scstream.close();
    istream.close();

  }
}

function openFileInNewWindow() {
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Open File", nsIFilePicker.modeOpen);
  fp.appendFilters(nsIFilePicker.filterAll);

  var rv = fp.show();
  if(rv == nsIFilePicker.returnOK) {
    var file = fp.file;

    // file is nsIFile
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    URL = fileHandler.getURLSpecFromFile(file);

    // open an input stream from file
    var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    istream.init(file, 0x01, 0444, 0);
    istream.QueryInterface(Components.interfaces.nsILineInputStream);

    // read first line
    var line = new Object();
    istream.readLine(line);
    var matchString = line.value;
    istream.close();

    // create stream to read all data
    istream.init(file, 0x01, 0444, 0);
    var scstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
    scstream.init(istream);

    // load document according to it's type
    // get file type (from first line)
    var block = loadFromStream(scstream, matchString);

    // create new window
    window.openDialog("try.xul", "_blank", "chrome, dialog=false", block, URL);

    scstream.close();
    istream.close();

  }
}


// load document from URL according to it's type
function loadFromURL(url) {
  URL = url;
  urlText.value = URL;

  if(gXMLHttpRequest) { // try to abort previouse operations
    try {
      gXMLHttpRequest.abort();
    }
    catch(ex) {
    }
  }

  gXMLHttpRequest = new XMLHttpRequest();
  gXMLHttpRequest.onreadystatechange = onreadystatechange;
  gXMLHttpRequest.open("GET", URL, true);
  gXMLHttpRequest.send(null);
}

function onreadystatechange() {
  document.getElementById("throbber").setAttribute("class", "loading");

  if (gXMLHttpRequest.readyState == 4) { // request completed
    document.getElementById("throbber").setAttribute("class", "loaded");
    // check responcse status
    if (gXMLHttpRequest.status == 200 || gXMLHttpRequest.status == 0) { // [BUG] for local files status == 0?
      // process xml document that has been recieved
      // create stream to read first line and other data
      var sstream = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
      sstream.setData(gXMLHttpRequest.responseText, -1);

      var scstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
      scstream.init(sstream);

      // load document according to it's type
      // get file type (from first line)
      gBlock = loadFromStream(scstream, gXMLHttpRequest.responseText);
      try {
        // create interface to invoke operations
        gBlock.decode(document.getElementById("block"));
      }
      catch(ex) {
        alert(ex);
      }
      document.getElementById("editSourceBroadcaster").setAttribute("disabled", "false");
      document.getElementById("saveAsBroadcaster").setAttribute("disabled", "false");
      document.getElementById("saveToMailboxBroadcaster").setAttribute("disabled", "false");
      if("send" in gBlock)
        document.getElementById("sendToolbarbutton").setAttribute("disabled", "false");
      else
        document.getElementById("sendToolbarbutton").setAttribute("disabled", "true");

      scstream.close();
      sstream.close();
    }
    else { // error
      alert("error while loading URL " + URL);
    }

  }
}

function loadFromStream(stream, matchString) {
  var blcok = null;

  // load document according to it's type
  // get file type (from first line)
  if(matchString.match(/^<\?xml /)) { // WSDL file
    try {
      // create wsdl wrapper
      block = new WSDLBrand(URL, stream, brandListener);
    }
    catch(ex) {
      alert(ex);
    }
  }
  else if(matchString.match(/^[^\x00-\x20:]+\s*:/)) { // RFC822 message (*.eml file)
    // the field-name (RFC822)
    // 1*<any CHAR, excluding CTLs, SPACE, and ":">
    try {
      // load from stream (scriptable input stream)
      var data = "";
      while (stream.available()) {
        data += stream.read(stream.available());
      }

      block = new RFC822Mauer(data);
    }
    catch(ex) {
      alert(ex);
    }

  }
  /*else if(matchString.match(/^From /)) { // Unix mailbox format
  }
  else { // wrong URL
  }*/

  return block;
}

// on operation select
function brandListener(evt) {
  try {
    var block = gBlock.encodeOperation(this.getAttribute("portQName"), this.getAttribute("operationQName"));
  }
  catch(ex) {
    alert(ex);
  }

  // create new window
  window.openDialog("try.xul", "_blank", "chrome, dialog=false", block);
}

// on response recieved
function mauerListener(evt) { // function onreadystatechange()
  document.getElementById("throbber").setAttribute("class", "loading");

  if (gBlock.request.readyState == 4) { // request completed
    document.getElementById("throbber").setAttribute("class", "loaded");
    // check responcse status
    if (gBlock.request.status == 200 || gBlock.request.status == 0) { // [BUG] for local files status == 0?
      // process text document that has been recieved
      try {
        var block = new SOAPResponseMauer(gBlock.to, gBlock.request.getAllResponseHeaders(), gBlock.request.responseText);

        // create new window
        window.openDialog("try.xul", "_blank", "chrome, dialog=false", block);
      }
      catch(ex) {
        alert(ex);
      }
    }
    else { // error
      alert("error while sending request");
    }

  }
}

function trySend() {
  try {
    gBlock.send(mauerListener);
  }
  catch(ex) {
    alert(ex);
  }
}

function editSource() {
  try {
    var message = gBlock.encode();
    window.openDialog("try.xul", "_blank", "chrome, dialog=false", new RFC822Mauer(message));

    //window.openDialog("source.xul", "_blank", "chrome, dialog=false", message);
  }
  catch(ex) {
    alert(ex);
  }
}

// [DEBUG] ---------------------------------------
function ddump(ex) {
  dump("----------------\n");
  dump(ex + "\n");
  for(j in ex) {
    dump(j + " = ");
    try {
      if(typeof(ex[j]) == "function")
        dump(typeof(ex[j]) + "\n");
      else
        dump(ex[j] + "\n");
    }
    catch(exception) {
      dump(exception + "\n");
    }
  }
  dump("----------------\n");
}
// [DEBUG] ---------------------------------------
